---
name: "utils-linux"
distro: "debian"
suites:
- "wheezy"
architectures:
- "i386"
- "amd64"
packages:
- "automake"
- "libtool"
- "zip"
- "hardening-wrapper"
# Needed for compiling gold.
- "bison"
# Needed for compiling GCC.
- "libmpc-dev"
# These packages are needed for Python due to HTTPS-Everywhere >= 3.5.
- "libsqlite3-dev"
- "zlib1g-dev"
- "libxml2-dev"
- "libxslt-dev"
# Needed for passing the Python related part of configure in ESR 31.
- "libssl-dev"
# Needed for binutils (64bit) as we are building with PIE enabled.
- "libstdc++6-4.7-pic"
# Needed for Selfrando
- "scons"
reference_datetime: "2000-01-01 00:00:00"
remotes:
- "url": "https://github.com/libevent/libevent.git"
  "dir": "libevent"
- "url": "https://github.com/immunant/selfrando.git"
  "dir": "selfrando"
files:
- "binutils.tar.bz2"
- "gcc.tar.bz2"
- "openssl.tar.gz"
- "gmp.tar.bz2"
- "go14.tar.gz"
- "go.tar.gz"
- "versions"
- "dzip.sh"
- "elfutils.tar.bz2"
- "binutils-224-gold.patch"
script: |
  INSTDIR="$HOME/install"
  source versions
  export TZ=UTC
  export LC_ALL=C
  export REFERENCE_DATETIME
  umask 0022

  # Config options for hardening-wrapper
  export DEB_BUILD_HARDENING=1
  export DEB_BUILD_HARDENING_STACKPROTECTOR=1
  export DEB_BUILD_HARDENING_FORTIFY=1
  export DEB_BUILD_HARDENING_FORMAT=1
  export DEB_BUILD_HARDENING_PIE=1

  ARCH=""
  SR_ARCH="x86"
  if [ $GBUILD_BITS == "64" ];
  then
    ARCH="64"
    SR_ARCH="x86_64"
  fi

  # Building Binutils
  tar xjf binutils.tar.bz2
  # The libstdc++ shipped by default is non-PIC which breaks the binutils build
  # if we build with DEB_BUILD_HARDENING_PIE=1. We need to install a PIC one AND
  # make sure it gets used before the non-PIC one would.
  if [ $GBUILD_BITS == "64" ];
  then
    ln -s /usr/lib/gcc/x86_64-linux-gnu/4.7/libstdc++_pic.a libstdc++.a
    export LDFLAGS="-L/home/debian -lstdc++"
  fi
  cd binutils*
  # We need to work around a gold linker bug in 2.24 to get selfrando working,
  # see bug 20683.
  patch -p1 < ../binutils-224-gold.patch
  # We want to use gold as the linker in our toolchain mainly as it is way
  # faster when linking Tor Browser code (especially libxul). But apart from
  # that it fixes #12103 and issues with ESR 31 and our Gitian setup as well
  # (see bug #12743).
  ./configure --prefix=$INSTDIR/binutils --disable-multilib --enable-gold --enable-plugins
  make $MAKEOPTS
  make install
  cd ..

  export LDFLAGS=""
  # We need to disable `-Werror=format-security` as GCC does not build with it
  # anymore. It seems it got audited for those problems already:
  # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=48817.
  export DEB_BUILD_HARDENING_FORMAT=0
  # Building GCC
  tar xjf gcc.tar.bz2
  cd gcc-*
  ./configure --prefix=$INSTDIR/gcc --disable-multilib --enable-languages=c,c++
  make $MAKEOPTS
  make install
  cd ..

  # Make sure we use the hardening wrapper
  pushd $INSTDIR/gcc/bin
  cp /usr/bin/hardened-cc ./
  mv gcc gcc.real
  mv c++ c++.real
  mv g++ g++.real
  ln -sf hardened-cc gcc
  ln -sf hardened-cc c++
  ln -sf hardened-cc g++
  popd

  # Make sure gold is used with the hardening wrapper for full RELRO, see
  # #13031.
  pushd $INSTDIR/binutils/bin
  rm ld
  cp /usr/bin/hardened-ld ./
  mv ld.gold ld.gold.real
  ln -sf hardened-ld ld.gold
  ln -sf ld.gold ld
  popd

  export DEB_BUILD_HARDENING_FORMAT=1
  export PATH="$INSTDIR/binutils/bin:$INSTDIR/gcc/bin:$PATH"
  export LD_LIBRARY_PATH="$INSTDIR/gcc/lib$ARCH"

  # Building Elfutils
  tar xjf elfutils.tar.bz2
  cd elfutils*/
  ./configure --prefix=$INSTDIR/elfutils
  make $MAKEOPTS
  make install
  cd ..

  # Building Selfrando
  cd selfrando
  scons -Q arch=$SR_ARCH LIBELF_PATH="$INSTDIR/elfutils" FORCE_INPLACE=1 DEBUG_LEVEL=env WRITE_LAYOUTS=env LOG=console
  mkdir -p $INSTDIR/selfrando
  cp out/$SR_ARCH/bin/* $INSTDIR/selfrando/
  cd ..

  # Building Libevent
  cd libevent
  ./autogen.sh
  find -type f -print0 | xargs -0 touch --date="$REFERENCE_DATETIME"
  ./configure --disable-static --prefix=$INSTDIR/libevent
  make $MAKEOPTS
  make install
  cd ..

  # Building OpenSSL
  tar xzf openssl.tar.gz
  cd openssl-*
  find -type f -print0 | xargs -0 touch --date="$REFERENCE_DATETIME"
  if [ $GBUILD_BITS == "64" ];
  then
    ./config -shared --prefix=$INSTDIR/openssl enable-ec_nistp_64_gcc_128
  else
    ./config -shared --prefix=$INSTDIR/openssl
  fi
  # Using $MAKEOPTS breaks the build. Might be the issue mentioned on
  # http://cblfs.cross-lfs.org/index.php/OpenSSL.
  make
  make install
  cd ..

  # Building GMP
  tar xjf gmp.tar.bz2
  cd gmp-*
  find -type f -print0 | xargs -0 touch --date="$REFERENCE_DATETIME"
  # Even if we are not shipping libgmpxx anymore we still need --enable-xcc
  # during compile time.
  # --enable-fat makes the binaries slightly bigger but fixes reproducibility
  # issues when compiling on LXC. See bug 12238 comment 4.
  ./configure --prefix=$INSTDIR/gmp --disable-static --enable-shared --enable-cxx --enable-fat
  make $MAKEOPTS
  make install
  cd ..

  # Building go 1.4.x
  # This is needed to bootstrap the go that we actually use
  # https://golang.org/doc/install/source#go14
  tar xvf go14.tar.gz --transform='s,^go\>,go1.4,'
  cd go1.4/src
  # Disable cgo to avoid conflicts with newer GCC. cgo is not needed for the bootstrap go.
  # https://github.com/golang/go/issues/13114#issuecomment-186922245
  CGO_ENABLED=0 ./make.bash
  cd ../..
  export GOROOT_BOOTSTRAP="$PWD/go1.4"

  # Building go
  # http://golang.org/doc/install/source#environment
  export GOROOT="$INSTDIR/go"
  tar xvf go.tar.gz
  cd go/src
  ./make.bash
  cd ../..
  # Let's get it zipped up.
  mv go $INSTDIR

  # Grabbing the remaining results and making sure timestamps don't spoil them
  # Since we stopped using libfaketime, the binutils, gcc, openssl,
  # libevent archives are no longer reproducible. The main reason
  # is that they include some .a archives which include timestamps.
  # Those files are however not part of the files we ship.
  # We use the --symlinks zip option for binutils and gcc for the
  # hardening wrappers symlinks
  cd $INSTDIR
  ZIPOPTS='--symlinks' ~/build/dzip.sh binutils-$BINUTILS_VER-linux$GBUILD_BITS-utils.zip binutils
  ZIPOPTS='--symlinks' ~/build/dzip.sh gcc-$GCC_VER-linux$GBUILD_BITS-utils.zip gcc
  ~/build/dzip.sh openssl-$OPENSSL_VER-linux$GBUILD_BITS-utils.zip openssl
  ~/build/dzip.sh libevent-${LIBEVENT_TAG#release-}-linux$GBUILD_BITS-utils.zip libevent
  ~/build/dzip.sh gmp-$GMP_VER-linux$GBUILD_BITS-utils.zip gmp
  ~/build/dzip.sh go-$GO_VER-linux$GBUILD_BITS-utils.zip go
  ~/build/dzip.sh selfrando-$SELFRANDO_TAG-linux$GBUILD_BITS-utils.zip selfrando
  cp *utils.zip $OUTDIR/
